diff --git a/configure.ac b/configure.ac
index bc6ed1c..94753d0 100644
--- a/configure.ac
+++ b/configure.ac
@@ -3028,16 +2969,14 @@ dnl H264 encoder plugin (using libx264)
 dnl
 VLC_FEATURE_OPTION([x264], [H264 encoding support with libx264])
 AS_IF([VLC_FEATURE_ENABLED([x264])], [
-  AC_ARG_WITH(x264-tree,
-    [  --with-x264-tree=PATH   x264 tree for static linking ],[],[])
-  if test "${with_x264_tree}" != "no" -a -n "${with_x264_tree}"
-  then
-    real_x264_tree="`cd ${with_x264_tree} 2>/dev/null && pwd`"
+  VLC_STRING_OPTION([x264-tree], [x264 tree for static linking], [PATH])
+  AS_IF([VLC_STRING_SET([x264-tree])], [
+    real_x264_tree="`cd ${vlc_string_x264_tree} 2>/dev/null && pwd`"
     if test -z "${real_x264_tree}"
     then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([${with_x264_tree} directory doesn't exist])
+      AC_MSG_ERROR([${vlc_string_x264_tree} directory doesn't exist])
     fi
     dnl  Use a custom libx264
     AC_MSG_CHECKING(for x264.h in ${real_x264_tree})
@@ -3061,7 +3000,7 @@ AS_IF([VLC_FEATURE_ENABLED([x264])], [
       AC_MSG_RESULT(no)
       AC_MSG_ERROR([the specified tree doesn't have x264.h])
     fi
-  else
+  ], [
       PKG_CHECK_MODULES(X264,x264 >= 0.76, [
         VLC_ADD_PLUGIN([x264])
         VLC_ADD_LDFLAGS([x264],[${X264_LIBS}])
@@ -3086,7 +3025,7 @@ AS_IF([VLC_FEATURE_ENABLED([x264])], [
           ])
       ])
     LDFLAGS="${LDFLAGS_save}"
-  fi
+  ])
 ])
 
 dnl
@@ -3326,12 +3265,10 @@ VLC_FEATURE_OPTION([sdl], [SDL support])
 VLC_FEATURE_OPTION([sdl-image], [SDL image support])
 AS_IF([VLC_FEATURE_ENABLED([sdl])], [
   SDL_PATH="${PATH}"
-  AC_ARG_WITH(sdl-config-path,
-    [  --with-sdl-config-path=PATH sdl-config path (default search in \$PATH)],
-    [ if test "${with_sdl_config_path}" != "no"
-      then
-        SDL_PATH="${with_sdl_config_path}:${PATH}"
-      fi ])
+  VLC_STRING_OPTION([sdl-config-path], [sdl-config path], [PATH], [search in \$PATH])
+    AS_IF([VLC_STRING_SET([sdl-config-path])], [
+      SDL_PATH="${vlc_string_sdl_config_path}:${PATH}"
+    ])
   AC_PATH_PROG(SDL_CONFIG, sdl-config, no, ${SDL_PATH})
   SDL_HEADER="SDL/SDL.h"
   SDL_IMAGE="SDL/SDL_image.h"
@@ -3552,20 +3489,19 @@ dnl  try to find using: 1 - given location; 2 - directfb-config; 3 - pkg-config
 dnl  TODO: support for static linking
 dnl
 VLC_FEATURE_OPTION([directfb], [DirectFB support], [disabled])
-AC_ARG_WITH(directfb,
-  [  --with-directfb=PATH    path to DirectFB headers and libraries])
+VLC_STRING_OPTION([directfb], [path to DirectFB headers and libraries], [PATH])
 AS_IF([VLC_FEATURE_ENABLED([directfb])], [
     have_directfb="false"
     CPPFLAGS_mydirectfb=
     LIBS_mydirectfb=
-    if test "${with_directfb}" != "no" -a -n "${with_directfb}"; then
+    AS_IF([VLC_STRING_SET([directfb])], [
         dnl Trying the given location
         CPPFLAGS_save="${CPPFLAGS}"
         LIBS_save="${LIBS}"
 
-        CPPFLAGS_new="-I${with_directfb}/include -D_REENTRANT -D_GNU_SOURCE"
-        LIBS_new="-L${with_directfb}/lib/fusion/.libs/ -L${with_directfb}/lib/direct/.libs/"
-        LIBS_new="${LIBS_new} -L${with_directfb}/src/.libs/"
+        CPPFLAGS_new="-I${vlc_string_directfb}/include -D_REENTRANT -D_GNU_SOURCE"
+        LIBS_new="-L${vlc_string_directfb}/lib/fusion/.libs/ -L${vlc_string_directfb}/lib/direct/.libs/"
+        LIBS_new="${LIBS_new} -L${vlc_string_directfb}/src/.libs/"
 
         CPPFLAGS="${CPPFLAGS} ${CPPFLAGS_new}"
         LIBS="${LIBS} ${LIBS_new}"
@@ -3587,7 +3523,7 @@ AS_IF([VLC_FEATURE_ENABLED([directfb])], [
             LIBS_mydirectfb="${LIBS_new} -lz -ldl -ldirectfb -lfusion -ldirect -lpthread"
             CPPFLAGS_mydirectfb="${CPPFLAGS_new}"
         fi
-    else
+    ], [
         dnl Look for directfb-config
         AC_PATH_PROG(DIRECTFB_CONFIG, directfb-config, no, ${PATH})
         if test "${DIRECTFB_CONFIG}" != "no"; then
@@ -3602,7 +3538,7 @@ AS_IF([VLC_FEATURE_ENABLED([directfb])], [
                 have_directfb="true"
                 ], [have_directfb="false"])
         fi
-    fi
+    ])
     if test "${have_directfb}" = "true"; then
         VLC_ADD_PLUGIN([directfb])
         VLC_ADD_CPPFLAGS([directfb],[${CPPFLAGS_mydirectfb}])
@@ -3622,13 +3558,11 @@ AS_IF([VLC_FEATURE_ENABLED([ggi])], [
   AC_CHECK_HEADER([ggi/ggi.h],[
     VLC_ADD_PLUGIN([ggi])
     VLC_ADD_LIBS([ggi],[-lggi])
-    AC_ARG_WITH(ggi,
-      [  --with-ggi=PATH         path to libggi],
-      [ if test "${with_ggi}" != "no" -a -n "${with_ggi}"
-        then
-          VLC_ADD_CPPFLAGS([ggi],[-I${with_ggi}/include])
-          VLC_ADD_LIBS([ggi],[-L${with_ggi}/lib])
-        fi ])
+    VLC_STRING_OPTION([ggi], [path to libggi], [PATH])
+    AS_IF([VLC_STRING_SET([ggi])], [
+      VLC_ADD_CPPFLAGS([ggi],[-I${vlc_string_ggi}/include])
+      VLC_ADD_LIBS([ggi],[-L${vlc_string_ggi}/lib])
+    ])
     ],[
        AC_MSG_ERROR([LibGGI development files can't be found])
     ])
@@ -3747,19 +3681,23 @@ dnl  CyberLink for C++ UPnP stack
 dnl
 VLC_FEATURE_OPTION([cyberlin], [CyberLink for C++ UPnP stack], [disabled])
   AS_IF([VLC_FEATURE_ENABLED([cyberlink])], [
-  AC_ARG_WITH(cyberlink-tree,
-    [  --with-cyberlink-tree=PATH CyberLink for C++ tree for static linking])
+  VLC_STRING_OPTION([cyberlink-tree], [CyberLink for C++ tree for static linking], [PATH])
 
   dnl
   dnl test for --with-cyberlink-tree
   dnl
-  AS_IF([test ! -z "${with_cyberlink_tree}" -a "${CXX}" != ""], [
+  AS_IF([{ VLC_STRING_SET([cyberlink-tree]) || test "x${have_contrib_libs}" = "xyes" ;} && test "${CXX}" != ""], [
     AC_LANG_PUSH(C++)
-    real_cyberlink_tree="`cd ${with_cyberlink_tree} 2>/dev/null && pwd`"
+    AS_IF([VLC_STRING_UNSET([cyberlink-tree])], [
+      try_cyberlink_tree="${CONTRIB_DIR}/src/clinkcc"
+    ], [
+      try_cyberlink_tree="${vlc_string_cyberlink_tree}"
+    ])
+    real_cyberlink_tree="`cd ${try_cyberlink_tree} 2>/dev/null && pwd`"
     AS_IF([test -z "${real_cyberlink_tree}"], [
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot cd to ${with_cyberlink_tree}])
+      AC_MSG_ERROR([cannot cd to ${try_cyberlink_tree}])
     ])
     CPPFLAGS_save="${CPPFLAGS}"
     CPPFLAGS_cyberlink="-I${real_cyberlink_tree}/include"
@@ -3770,7 +3708,7 @@ VLC_FEATURE_OPTION([cyberlin], [CyberLink for C++ UPnP stack], [disabled])
       ],[
         AC_MSG_ERROR([cannot find CyberLink for C++ headers])
       ])
-    AC_MSG_CHECKING(for libclink.a in ${with_cyberlink_tree})
+    AC_MSG_CHECKING(for libclink.a in ${try_cyberlink_tree})
     AS_IF([test -f "${real_cyberlink_tree}/lib/unix/libclink.a"], [
       AC_MSG_RESULT(${real_cyberlink_tree}/lib/unix/libclink.a)
       dnl The mere fact that we have to make such an ugly check sucks
@@ -3806,7 +3744,7 @@ class testclass : public SearchResponseListener, public MediaPlayer
       VLC_ADD_LIBS([upnp_cc], [${real_cyberlink_tree}/lib/unix/libclink.a -lpthread ${LIBS_cclink}])
     ], [
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot find ${real_cyberlink_tree}/lib/unix/libclink.a, make sure you compiled CyberLink for C++ in ${with_cyberlink_tree}])
+      AC_MSG_ERROR([cannot find ${real_cyberlink_tree}/lib/unix/libclink.a, make sure you compiled CyberLink for C++ in ${try_cyberlink_tree}])
     ])
     CPPFLAGS="${CPPFLAGS_save}"
     AC_LANG_POP([C++])
@@ -4239,30 +4177,29 @@ dnl
 dnl SQLite
 dnl
 VLC_FEATURE_OPTION([sqlite], [sqlite support])
-AC_ARG_WITH(sqlite,
-  [  --with-sqlite=PATH      sqlite path linking])
+VLC_STRING_OPTION([sqlite], [sqlite path linking], [PATH])
 if test "${SYS}" != "darwin"; then
   PKG_ENABLE_MODULES_VLC([SQLITE], [], [sqlite3 >= 3.6.0], [sqlite3], [auto])
 else
   AS_IF([VLC_FEATURE_ENABLED([sqlite])], [
     AC_CHECK_HEADERS(sqlite3.h, [
         VLC_ADD_PLUGIN([sqlite])
-        if test "${with_sqlite}" != "no" -a -n "${with_sqlite}"; then
-          AC_MSG_CHECKING(existence of sqlite directory in ${with_sqlite})
-          real_sqlite="`cd ${with_sqlite} 2>/dev/null && pwd`"
+        AS_IF([VLC_STRING_SET([sqlite])], [
+          AC_MSG_CHECKING(existence of sqlite directory in ${vlc_string_sqlite})
+          real_sqlite="`cd ${vlc_string_sqlite} 2>/dev/null && pwd`"
           if test -z "${real_sqlite}"
           then
             dnl  The given directory can't be found
             AC_MSG_RESULT(no)
-            AC_MSG_ERROR([cannot cd to ${with_sqlite}])
+            AC_MSG_ERROR([cannot cd to ${vlc_string_sqlite}])
           fi
-          VLC_ADD_CFLAGS([sqlite],[-I${with_sqlite}/include])
-          VLC_ADD_LIBS([sqlite], [-L${with_sqlite}/lib -lsqlite3])
+          VLC_ADD_CFLAGS([sqlite],[-I${vlc_string_sqlite}/include])
+          VLC_ADD_LIBS([sqlite], [-L${vlc_string_sqlite}/lib -lsqlite3])
           AC_MSG_RESULT(yes)
           have_sqlite="yes"
-        else
+        ], [
           VLC_ADD_LIBS([sqlite], [-lsqlite3])
-        fi
+        ])
         AC_DEFINE([SQLITE_MODULE], 1, [Define if you want to use SQLite module]) ],
         AC_MSG_ERROR([sqlite3 is required for sqlite module]) )
   ])
@@ -4313,17 +4250,15 @@ AS_IF([test "${SYS}" = "mingw32"], [
   VLC_FEATURE_DEFAULT_DISABLE([activex])
 ])
 VLC_FEATURE_OPTION([activex], [build a vlc-based ActiveX control], [enabled on Win32])
-AC_ARG_WITH(wine-sdk-path,
-  [  --with-wine-sdk-path=PATH path to wine sdk])
+VLC_STRING_OPTION([wine-sdk-path], [path to wine sdk], [PATH])
 AS_IF([VLC_FEATURE_ENABLED([activex]) && test "${SYS}" = "mingw32"], [
     AC_CHECK_PROGS(MIDL, [midl], no)
-    if test "${with_wine_sdk_path}" != ""
-    then
-       WINE_SDK_PATH=${with_wine_sdk_path}
+    AS_IF([VLC_STRING_SET([wine-sdk-path])], [
+       WINE_SDK_PATH=${vlc_string_wine_sdk_path}
        AC_PATH_PROG(WIDL, widl, no, [$WINE_SDK_PATH/bin:$WINE_SDK_PATH/tools/widl])
-    else
+    ], [
        WIDL=no
-    fi
+    ])
     AC_LANG_PUSH(C++)
     AC_CHECK_HEADERS(ole2.h,
       [AC_CHECK_HEADERS(olectl.h,
@@ -4358,13 +4293,11 @@ dnl  Mozilla plugin
 dnl
 mozilla=false
 VLC_FEATURE_OPTION([mozilla], [build a vlc-based Firefox/Mozilla plugin], [disabled])
-AC_ARG_WITH(mozilla-sdk-path,
-  [  --with-mozilla-sdk-path=PATH path to mozilla sdk])
-AC_ARG_WITH(mozilla-pkg,
-  [  --with-mozilla-pkg=PKG  look for PKG.pc to build the mozilla plugin.])
+VLC_STRING_OPTION([mozilla-sdk-path], [path to mozilla sdk], [PATH])
+VLC_STRING_OPTION([mozilla-pkg], [look for PKG.pc to build the mozilla plugin.], [PKG])
 AC_LANG_PUSH(C++)
 AS_IF([VLC_FEATURE_ENABLED([mozilla])], [
-  AS_IF([test "${with_mozilla_sdk_path}" = "" -o "${with_mozilla_sdk_path}" = "no"],
+  AS_IF([VLC_STRING_UNSET([mozilla-sdk-path])],
     [
     dnl pkg-config
     dnl As we want to do a loop due to the number of name possible for the .pc
@@ -4379,7 +4312,7 @@ AS_IF([VLC_FEATURE_ENABLED([mozilla])], [
       found=1
     else
       if test -n "$PKG_CONFIG"; then
-	for i in "${with_mozilla_pkg}" libxul {seamonkey,iceape,xulrunner,firefox,iceweasel,mozilla}-plugin; do
+	for i in "${vlc_string_mozilla_pkg}" libxul {seamonkey,iceape,xulrunner,firefox,iceweasel,mozilla}-plugin; do
 	  echo "Trying to find $i.pc files" >&5
 	  if $PKG_CONFIG --exists --print-errors "$i" 2>&5
 	  then
@@ -4470,18 +4403,22 @@ AS_IF([VLC_FEATURE_ENABLED([mozilla])], [
       MOZILLA_SDK_PATH="`${MOZILLA_CONFIG} --prefix`"
     ])
     dnl End of moz_sdk = ""
-  ],[
+  ])
+
+  AS_IF([{ VLC_STRING_SET([mozilla-sdk-path]) || test "x${have_contrib_libs}" = "xyes" ;}], [
+    AS_IF([VLC_STRING_UNSET([mozilla-sdk-path])], [
+      try_sdk_path="${CONTRIB_DIR}/gecko-sdk"
+    ], [
+      try_sdk_path="${vlc_string_mozilla_sdk_path}"
+    ])
+
     dnl special case for mingw32
     if test "${SYS}" = "mingw32"
     then
       AC_CHECK_TOOL(CYGPATH, cygpath, "")
-      dnl latest gecko sdk does not have an xpcom directory
-      if test -d "${with_mozilla_sdk_path}/xpcom"; then
-          mozilla_sdk_xpcom="/xpcom"
-      fi
     fi
 
-    real_mozilla_sdk="`cd ${with_mozilla_sdk_path} 2>/dev/null && pwd`"
+    real_mozilla_sdk="`cd ${try_mozilla_sdk_path} 2>/dev/null && pwd`"
     CPPFLAGS="${CPPFLAGS_save} -I${real_mozilla_sdk} -I${real_mozilla_sdk}/include"
     MOZILLA_REQUIRED_HEADERS=1
     AC_CHECK_HEADERS(mozilla-config.h,,MOZILLA_REQUIRED_HEADERS=0)
diff --git a/m4/vlc_features.m4 b/m4/vlc_features.m4
index ee31713..ae11445 100644
--- a/m4/vlc_features.m4
+++ b/m4/vlc_features.m4
@@ -77,10 +77,23 @@ AC_DEFUN([VLC_FEATURE_DEFAULT_DISABLE], [
   _VLC_FEATURE_DEFAULT([$1], [no])
 ])
 
+dnl VLC_STRING_FORCE(WITH-STRING, VALUE, [REASON])
+dnl Force string option WITH-STRING to be set to VALUE.
+AC_DEFUN([VLC_STRING_FORCE], [
+  [vlc_string_force_]_VLC_FEATURE_STRING([$1])[="]$2["]
+  AS_ECHO(["Assuming --with-$1=$2]m4_quote(m4_ifnblank([$2], [ $2]))["])
+])
+
+dnl VLC_STRING_DEFAULT(WITH-STRING, VALUE)
+dnl Set string option to VALUE by default.
+AC_DEFUN([VLC_STRING_DEFAULT], [
+  [vlc_string_default_]_VLC_FEATURE_STRING([$1])[="]$2["]
+])
+
 
 
 dnl ==========================================================================
-dnl Macros for probing the state of features.
+dnl Macros for probing the state of features and string options.
 dnl ==========================================================================
 
 dnl VLC_FEATURE_(NOT_)FORCE_ENABLED/DISABLED(ENABLE-STRING)
@@ -112,10 +125,36 @@ AC_DEFUN([VLC_FEATURE_DEFAULT_ENABLED],
 AC_DEFUN([VLC_FEATURE_DEFAULT_DISABLED],
   [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature_default], [= "xno" ])])
 
+dnl VLC_STRING_(NOT_)FORCED(WITH-STRING)
+dnl Check if a string is (or isn't) forced to be set.
+AC_DEFUN([VLC_STRING_FORCED],
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_string_force], [!= "x" ])])
+AC_DEFUN([VLC_STRING_NOT_FORCED],
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_string_force], [= "x" ])])
+
+dnl VLC_STRING_(NOT_)USER_SET(WITH-STRING)
+dnl Check if a string is (or isn't) passed via ./configure.
+AC_DEFUN([VLC_STRING_USER_SET],
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [with], [!= "x" ])])
+AC_DEFUN([VLC_STRING_NOT_USER_SET],
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [with], [= "x" ])])
+
+dnl VLC_STRING_(NOT_)DEFAULT_SET(WITH-STRING)
+dnl Check if a string is (or isn't) default set by configure.ac authors.
+AC_DEFUN([VLC_STRING_DEFAULT_SET],
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_string_default], [!= "x" ])])
+AC_DEFUN([VLC_STRING_NOT_DEFAULT_SET],
+  [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_string_default], [= "x" ])])
+
+dnl VLC_STRING(WITH-STRING)
+dnl Obtain the string value for a string option.
+AC_DEFUN([VLC_STRING], [
+])
+
 
 
 dnl ==========================================================================
-dnl Convenient macros for probing the state of features.
+dnl Convenient macros for probing the state of features and string options.
 dnl ==========================================================================
 
 dnl VLC_FEATURE_(NOT_)REQUESTED/REMOVED(ENABLE-STRING)
@@ -145,6 +184,22 @@ AC_DEFUN([VLC_FEATURE_ENABLED],
 AC_DEFUN([VLC_FEATURE_DISABLED],
   [_VLC_FEATURE_CHECK_VARIABLE([$1], [vlc_feature], [= "xno"])])
 
+dnl VLC_STRING_REQUESTED(WITH-STRING)
+dnl VLC_STRING_NOT_REQUESTED(WITH-STRING)
+dnl Check if a string option is (or isn't) forced or user set.
+AC_DEFUN([VLC_STRING_REQUESTED],
+  [{ ][VLC_STRING_FORCED([$1])][ || ][VLC_STRING_USER_SET([$1])][; }])
+AC_DEFUN([VLC_STRING_NOT_REQUESTED],
+  [AS_IF([VLC_STRING_REQUESTED([$1])], [false], [true])])
+
+dnl VLC_STRING_SET(WITH-STRING)
+dnl VLC_STRING_UNSET(WITH-STRING)
+dnl Check if a string option is (or isn't) explicitly or default set.
+AC_DEFUN([VLC_STRING_SET],
+  [{ ][VLC_STRING_REQUESTED([$1])][ || ][VLC_STRING_DEFAULT_SET([$1])][; }])
+AC_DEFUN([VLC_STRING_UNSET],
+  [AS_IF([VLC_STRING_SET([$1])], [false], [true])])
+
 
 
 dnl ==========================================================================
@@ -207,3 +262,39 @@ AC_DEFUN([VLC_FEATURE_OPTION], [
   m4_popdef([var])
   m4_popdef([with_without])
 ])
+
+dnl VLC_STRING_OPTION(WITH-STRING, DESCRIPTION, VARIABLE,
+dnl                   [DEFAULT-STRING])
+dnl
+dnl Wrap around AC_ARG_WITH to provide string parameters for VLC.
+dnl DESCRIPTION should contain an informative string describing what
+dnl the VARIABLE is used for (you should use VARIABLE inside it).
+dnl VARIABLE is the right hand side of the assignment, so:
+dnl --with-foo=VARIABLE.
+dnl DEFAULT-STRING is optional and will be used in AS_HELP_STRING.
+dnl The resulting string is stored in vlc_string_WITH_STRING.
+AC_DEFUN([VLC_STRING_OPTION], [
+  m4_pushdef([default_string],
+             [m4_ifnblank([$4], [ @<:@default: ]m4_quote([$4])[@:>@])])
+  m4_pushdef([var], [vlc_string_]_VLC_FEATURE_STRING([$1]))
+
+  m4_ifblank([$2], [m4_fatal([Don't leave description blank for $1])])
+  m4_ifblank([$3], [m4_fatal([Don't leave variable blank for $1])])
+
+  AC_ARG_WITH([$1], [AS_HELP_STRING([--with-$1=]$3, m4_quote([$2]default_string))])
+
+  AS_IF([test "x][VLC_STRING([$1])][" = "xno"], [
+    AC_MSG_WARN(["no" is an uncommon string for --with-$1])
+  ])
+
+  AS_IF([VLC_STRING_FORCED([$1])], var[="${vlc_string_force_]_VLC_FEATURE_STRING([$1])[}"],
+    AS_IF([VLC_STRING_USER_SET([$1])], var[="${with_]_VLC_FEATURE_STRING([$1])[}"],
+      AS_IF([VLC_STRING_DEFAULT_SET([$1])],
+        var[="${vlc_string_default_]_VLC_FEATURE_STRING([$1])[}"]
+      )
+    )
+  )
+
+  m4_popdef([var])
+  m4_popdef([default_string])
+])
-- 
1.6.6.1


